

vehicleParts = {
	chassis = {

	},
	turrets = {

		["turret1"] = {
			smokeLauncher = {launcherType="btr90_smoke_turret", group="smoke"}

		}

	},
	guns = {
		["tankCannon1"] = {	
			name="Bad_Boy_Disco",
			magazines = {
						[1] = {name="APHE",
						maxPenDepth = 1.2,
					},
						[2] = {name="HE-I",
						maxPenDepth = 1.2,
						payload = "HE-I",
					},
						[3] = {
												velocity = 20,
												gravityCoef=0,
												dispersionCoef=0,				

												
												},
						[4] = {name="HEAT",
						maxPenDepth = 1.2,
						payload = "HEAT",
					},
						[5] = {name="GUIDED",
						maxPenDepth = 1.2,
						payload = "guided",
					},
						[6] = {name="LOW VEL AP",
						maxPenDepth = 1.2,
						payload = "kinetic",
												velocity = 20,
												gravityCoef=0,
												dispersionCoef=0,	
					},
			},
				zoomSight 				= "MOD\BTR-90\gfx\sight.png"
			},
		["tankCoax1"] = {
					name						= "KPV",
					magazines 					= {
											[1] = {
												name = "14.5×114mm",
												maxPenDepth = 0.8,
												calibre = 14.5,
												maxPenDepth = 0.5,
												payload = "HE-I",
												magazineCapacity = 500,
												rpm= 100,
												tracer 					= 1,
												tracerL					= 3,
												tracerW					= 2,
												tracerR					= 1.0,
												tracerG					= 1.9, 
												tracerB					= 1.0,				

												
												},
											},
											soundFile 				=	"LEVEL/T90/sounds/HeavyMG0",
											mouseDownSoundFile 		=	"LEVEL/T90/sounds/HeavyMG4",		
		}

	},
	}

	---- magazine num _ val
	---- barrels num value

vehicle = {

}

function init()
	shapes = setmetatable({},{
		__index = function(t, k)
			local shape = FindShape(k)
			rawset(t, k, shape)
			return shape
		end
	})

	lights = setmetatable({},{
		__index = function(m, n)
			local light = FindLight(n)
			rawset(m, n, light)
			return light
		end
	})

	mlo = false
	hlo = false
    spotlight_on = false
	note = false
	n1 = false
	tl = false
	tr = false
	warning = false
	flash = false
	adt = false
	horn1 = LoadLoop("MOD/BTR-90/sounds/horn.ogg")


	local sceneVehicle = FindVehicle("cfg")
		local value = GetTagValue(sceneVehicle, "cfg")
		if(value == "vehicle") then
			vehicle.id = sceneVehicle

			local status,retVal = pcall(initVehicle)
			if status then 
				-- utils.printStr("no errors")
			else
				DebugPrint(retVal)
			end
			-- initVehicle()
		end

		SetTag(sceneVehicle,"AVF_Custom","unset")
end

function initVehicle()
	if unexpected_condition then error() end
	vehicle.body = GetVehicleBody(vehicle.id)
	vehicle.transform =  GetBodyTransform(vehicle.body)
	vehicle.shapes = GetBodyShapes(vehicle.body)
	local totalShapes = ""
	for i=1,#vehicle.shapes do
		local value = GetTagValue(vehicle.shapes[i], "component")
		if(value~= "")then
			if(value=="chassis") then
				for key,val in pairs(vehicleParts.chassis) do 
					if(HasTag(vehicle.shapes[i],key)) then
						addItems(vehicle.shapes[i],val)
					end
				end
			end
			totalShapes = totalShapes..value.." "
			local test = GetShapeJoints(vehicle.shapes[i])
				for j=1,#test do 
					local val2 = GetTagValue(test[j], "component")
					if(val2~= "")then

						
						totalShapes = totalShapes..val2.." "

						if(val2=="turretJoint")then

							totalShapes = totalShapes..traverseTurret(test[j], vehicle.shapes[i])

						elseif val2=="gunJoint" then
							

							totalShapes = totalShapes..addGun(test[j], vehicle.shapes[i])

						end
					end
				end
		end	
	end
end

function traverseTurret(turretJoint,attatchedShape)
	local outString = ""
	local turret = GetJointOtherShape(turretJoint, attatchedShape)
	local joints = GetShapeJoints(turret)

	for j=1,#joints do 
		if(joints[j]~=turretJoint)then
			local val2 = GetTagValue(joints[j], "component")

			-- DebugPrint("turret shapes:"..val2)
			if(val2=="turretJoint")then

				totalShapes = totalShapes..traverseTurret(joints[j], turret)

			elseif val2=="gunJoint" then
				outString = outString..addGun(joints[j], turret)
			end
		end
	end
	for key,val in pairs(vehicleParts.turrets) do 
		if(HasTag(turret,val)) then
			addItems(turret,key)
		end
	end
	return outString
end

function addGun(gunJoint,attatchedShape)
	local gun = GetJointOtherShape(gunJoint, attatchedShape)
	for key,val in pairs(vehicleParts.guns) do 
		
		if(HasTag(gun,key)) then
			-- DebugPrint(key)
			addItems(gun,val)
		end
	end
	local val3 = GetTagValue(gun, "component")
	return val3
end
-- @magazine1_tracer
function addItems(shape,values)
	for key,val in pairs(values) do 
			if(type(val)== 'table') then
				SetTag(shape, "@"..key)
				for subKey,subVal in pairs(val) do 
					if(type(subVal)== 'table') then
						for subKey2,subVal2 in pairs(subVal) do 
							-- DebugPrint( "@"..string.sub(key,1,-2)..subKey.."_"..subKey2.."="..subVal2)
							if key == "magazines" then
								
								SetTag(shape, "@"..string.sub(key,1,-2)..subKey.."_"..subKey2, subVal2)
							else
								SetTag(shape, "@"..key..subKey..subKey2, subVal2)
							end

						end
					else
						if key == "magazines" then
							SetTag(shape, "@"..string.sub(key,1,-2).."_"..subKey, subVal)
						else
							SetTag(shape, "@"..key..subKey, subVal)
						end
					end
				end
			else
				SetTag(shape, "@"..key,val)
			end		
	end
end

utils = {
	contains = function(set,key)
		return set[key] ~= nil
	end,
	}

	
	-- init lights
function tick(dt)
	lightrigger = FindTrigger("lighttrigger")
	
	v = FindVehicle("BTR90", false)
	local t = Transform(GetVehicleTransform(v).pos, Vec(0,1,0))
	SetTriggerTransform(lightrigger, t)

    if IsPointInTrigger(lightrigger, GetPlayerPos()) then

    if GetBool("game.player.useVehicle") then
        if note then
        else
            SetString("hud.notification", "'N'\t \t \t Turret Spotlight \n 'B'\t \t \t Low-beam / turn headlights on \n 'K'\t \t \t High-beam \n '  ,  (<)' & '  .  (>)'\t \t \t Blinkers \n 'U' \t \t \t Warning Lights \n 'L' \t \t \t Light Signal")
            note = true
        end
    end

    if GetBool("game.player.useVehicle") and InputPressed("v") then
        mlo = not mlo
    end

    if GetBool("game.player.useVehicle") and InputPressed("n") then
        spotlight_on = not spotlight_on
    end

    if GetBool("game.player.useVehicle") and InputPressed("m") then
        hi_spotlight_on = not hi_spotlight_on
    end

    if GetBool("game.player.useVehicle") and InputPressed("b") then
        hlo = not hlo
    end

    if GetBool("game.player.useVehicle") and InputPressed(",") then
        tl = not tl
        tr = false
        warning = false
        to = GetTime()
    end

    if GetBool("game.player.useVehicle") and InputPressed(".") then
        tr = not tr
        tl = false
        warning = false
        to = GetTime()
    end

    if GetBool("game.player.useVehicle") and InputPressed("u") then
        warning = not warning
        tl = false
        tr = false
        to = GetTime()
    end

    if GetBool("game.player.useVehicle") and InputDown("l") then
        flash = true
    else
        flash = false
    end

    if GetBool("game.player.useVehicle") and InputPressed("h") then
        adt = not adt
    end
    
    if GetBool("game.player.useVehicle") and InputDown("h")then
        PlayLoop(horn1,GetVehicleTransform(v).pos, 1) 
    end
end

    if tl or tr or warning then

        a = math.cos((GetTime()-to)*9)

        if a >= 0 then
            tli = 1  
        else
            tli = 0.0001 
        end 
 
        if warning then   
            SetShapeEmissiveScale(shapes.tlfl, tli)
            SetShapeEmissiveScale(shapes.tlbl, tli)
            SetShapeEmissiveScale(shapes.tlfr, tli)
            SetShapeEmissiveScale(shapes.tlbr, tli)
            SetLightIntensity(lights.tlflp, tli)
            SetLightIntensity(lights.tlblp, tli)
            SetLightIntensity(lights.tlfrp, tli)
            SetLightIntensity(lights.tlbrp, tli)

        else
            if tl then
                SetShapeEmissiveScale(shapes.tlfl, tli)
                SetShapeEmissiveScale(shapes.tlbl, tli)
                SetShapeEmissiveScale(shapes.tlfr, 0)
                SetShapeEmissiveScale(shapes.tlbr, 0)
                SetLightIntensity(lights.tlflp, tli)
                SetLightIntensity(lights.tlblp, tli)
                SetLightIntensity(lights.tlfrp, 0)
                SetLightIntensity(lights.tlbrp, 0)

            elseif tr then
                SetShapeEmissiveScale(shapes.tlfr, tli)
                SetShapeEmissiveScale(shapes.tlbr, tli)
                SetShapeEmissiveScale(shapes.tlfl, 0)
                SetShapeEmissiveScale(shapes.tlbl, 0)
                SetLightIntensity(lights.tlflp, 0)
                SetLightIntensity(lights.tlblp, 0)
                SetLightIntensity(lights.tlfrp, tli)
                SetLightIntensity(lights.tlbrp, tli)

            else
                SetShapeEmissiveScale(shapes.tlfl, 0)
                SetShapeEmissiveScale(shapes.tlbl, 0)
                SetShapeEmissiveScale(shapes.tlfr, 0)
                SetShapeEmissiveScale(shapes.tlbr, 0)
                SetLightIntensity(lights.tlflp, 0)
                SetLightIntensity(lights.tlblp, 0)
                SetLightIntensity(lights.tlfrp, 0)
                SetLightIntensity(lights.tlbrp, 0)
            end
        end
    else
        SetShapeEmissiveScale(shapes.tlfl, 0)
        SetShapeEmissiveScale(shapes.tlbl, 0)
        SetShapeEmissiveScale(shapes.tlfr, 0)
        SetShapeEmissiveScale(shapes.tlbr, 0)
        SetLightIntensity(lights.tlflp, 0)
        SetLightIntensity(lights.tlblp, 0)
        SetLightIntensity(lights.tlfrp, 0)
        SetLightIntensity(lights.tlbrp, 0)

    end

    if flash then
        SetLightIntensity(lights.lflmr, 100)
        SetLightIntensity(lights.lflml, 100)
        SetLightIntensity(lights.lfrmr, 100)
        SetLightIntensity(lights.lfrml, 100)

        SetShapeEmissiveScale(shapes.lflm, 1)
        SetShapeEmissiveScale(shapes.lfrm, 1)
        SetShapeEmissiveScale(shapes.lflmt, 1)
        SetShapeEmissiveScale(shapes.lfrmt, 1)

        SetLightIntensity(lights.lflmrt, 0.2)
        SetLightIntensity(lights.lflmlt, 0.2)
        SetLightIntensity(lights.lfrmrt, 0.2)
        SetLightIntensity(lights.lfrmlt, 0.2)
    else

        if mlo then
            SetShapeEmissiveScale(shapes.lflm, 1)
            SetShapeEmissiveScale(shapes.lfrm, 1)
            SetShapeEmissiveScale(shapes.lflmt, 1)
            SetShapeEmissiveScale(shapes.lfrmt, 1)
        else
            SetShapeEmissiveScale(shapes.lflm, 0)
            SetShapeEmissiveScale(shapes.lfrm, 0)
            SetShapeEmissiveScale(shapes.lflmt, 0)
            SetShapeEmissiveScale(shapes.lfrmt, 0)
        end

        -- spotlight

        if spotlight_on then 
            SetShapeEmissiveScale(shapes.spotlight, 1)
            SetShapeEmissiveScale(shapes.spotlight2, 1)
        else
            SetShapeEmissiveScale(shapes.spotlight, 0)
            SetShapeEmissiveScale(shapes.spotlight2, 0)
        end

        if spotlight_on and hi_spotlight_on then 
            SetLightIntensity(lights.spotlightl, 800)
            SetLightIntensity(lights.spotlightl2, 800)
        elseif spotlight_on then
            SetLightIntensity(lights.spotlightl, 200)
            SetLightIntensity(lights.spotlightl2, 200)
        else
            SetLightIntensity(lights.spotlightl, 0.0001)
            SetLightIntensity(lights.spotlightl2, 0.0001)
        end

        -- headlights

        if mlo and hlo then 
            SetLightIntensity(lights.lflmr, 100)
            SetLightIntensity(lights.lflml, 100)
            SetLightIntensity(lights.lfrmr, 100)
            SetLightIntensity(lights.lfrml, 100)
            SetLightIntensity(lights.lflmrt, 2)
            SetLightIntensity(lights.lflmlt, 0.2)
            SetLightIntensity(lights.lfrmrt, 0.2)
            SetLightIntensity(lights.lfrmlt, 0.2)
        elseif mlo then
            SetLightIntensity(lights.lflmr, 10)
            SetLightIntensity(lights.lflml, 10)
            SetLightIntensity(lights.lfrmr, 10)
            SetLightIntensity(lights.lfrml, 10)
            SetLightIntensity(lights.lflmrt, 0.2)
            SetLightIntensity(lights.lflmlt, 0.2)
            SetLightIntensity(lights.lfrmrt, 0.2)
            SetLightIntensity(lights.lfrmlt, 0.2)
        else
            SetLightIntensity(lights.lflmr, 0.0001)
            SetLightIntensity(lights.lflml, 0.0001)
            SetLightIntensity(lights.lfrmr, 0.0001)
            SetLightIntensity(lights.lfrml, 0.0001)
            SetLightIntensity(lights.lflmrt, 0.0001)
            SetLightIntensity(lights.lflmlt, 0.0001)
            SetLightIntensity(lights.lfrmrt, 0.0001)
            SetLightIntensity(lights.lfrmlt, 0.0001)
        end

        if mlo and adt then
            SetShapeEmissiveScale(shapes.hl, 1)
            SetShapeEmissiveScale(shapes.hl2, 1)
            SetLightIntensity(lights.hll, 20)
            SetLightIntensity(lights.hll2, 20)
        else
            SetShapeEmissiveScale(shapes.hl, 0)
            SetShapeEmissiveScale(shapes.hl2, 0)
            SetLightIntensity(lights.hll, 0)
            SetLightIntensity(lights.hll2, 0)
        end
    end
end